
public class ReturnDemo {

    public static void main (String[] args) { // (1) void method can use return.
        if (args.length == 0) return;
        output(checkValue(args.length));
    }

    static void output(int value) { // (2) void method need not use return.
        System.out.println(value);
//      return 'a';                 // Not OK. Cannot return a value.
    }

    static int checkValue(int i) {  // (3) non-void method must return a value.
        if (i > 3)
           return i;                // OK.
        else
//         return 2.0;              // Not OK. double not assignable to int.
           return 2;

    }
}